%define pkgname gperftools
Summary: Google perftools library
Summary(ko): 구글 퍼포먼스 도구 라이브러리
Name: google-perftools
Version: 2.1
Release: 2%{?dist}
Epoch: 1
License: BSD
Group: System Environment/Libraries
Source0: https://gperftools.googlecode.com/files/gperftools-%{version}.tar.gz
Source1: gperftools-compat-1.9.1-1.x86.tar.bz2
Source2: gperftools-compat-1.9.1-1.x86_64.tar.bz2
Buildroot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
URL: http://code.google.com/p/google-perftools
BuildRequires: glibc gcc make tar gzip libunwind-devel >= 1.1
Requires: libunwind >= 1.1
BuildRequires: info

%description
These tools are for use by developers so that they can create more robust applications.
Especially of use to those developing multi-threaded applications in C++ with templates.
Includes TCMalloc, heap-checker, heap-profiler and cpu-profiler. 

%package utils
Summary: CPU or HEAP profile utility for Google perftools
Summary(ko): Google perftools의 CPU/HEAP profile 도구
Group: Applications/Engineering
Requires: google-perftools = %{epoch}:%{name}-%{version}

%description utils
CPU or HEAP profile utility for Google perftools

%package devel
Summary: Libraries and header files for Google perftools
Summary(ko): Google perftools 개발 라이브러리 및 헤더 파일
Group: Development/Libraries
Requires: google-perftools = %{epoch}:%{name}-%{version}
Requires: tcmalloc = %{epoch}:%{name}-%{version}

%description devel
The %{name}-devel package contains the header and object files
necessary for developing programs which use the %{name} libraries.

%package doc
Summary: Google perftools documents
Summary(ko): Google perftools 문서
Group: Documentation
Requires: google-perftools = %{epoch}:%{name}-%{version}

%description doc
Google Perftools documentation

%package -n tcmalloc
Summary: Google perftools tcmalloc-minimal
Summary(ko): Google perftools 문서
Group: System Environment/Libraries

%description -n tcmalloc
Google Perftools tcmalloc-minimal libraries

%prep
%setup -q -n %{pkgname}-%{version}

# No need to have exec permissions on source code
chmod -x src/sampler.h src/sampler.cc

# Hey, I bet this still works.
sed -i 's|2.68|2.63|g' configure.ac
autoreconf -i

%build
CFLAGS=`echo $RPM_OPT_FLAGS -fno-strict-aliasing -Wno-unused-local-typedefs -DTCMALLOC_LARGE_PAGES | sed -e 's/-Wp,-D_FORTIFY_SOURCE=2//g' | sed -e 's|-fexceptions||g'`
CXXFLAGS=`echo $RPM_OPT_FLAGS -fno-strict-aliasing -Wno-unused-local-typedefs -DTCMALLOC_LARGE_PAGES | sed -e 's/-Wp,-D_FORTIFY_SOURCE=2//g' | sed -e 's|-fexceptions||g'`
%configure

# Bad rpath!
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

%{__make} %{?_smp_mflags}

%install
%{__make} install DESTDIR="%{buildroot}"
find $RPM_BUILD_ROOT -name '*.la' -exec rm -f {} ';'

(
cd %{buildroot}%{_libdir}
%ifarch x86_64
	tar xvfpj %{SOURCE2}
%else
	tar xvfpj %{SOURCE1}
%endif
cd -
)

%clean
rm -rf %{buildroot}

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%post -n tcmalloc
/sbin/ldconfig

%postun -n tcmalloc
/sbin/ldconfig

%files
%defattr(0755,root,root)
%exclude %{_libdir}/libtcmalloc_minimal*.so.*
%{_libdir}/*.so.*

%files -n tcmalloc
%defattr(0755,root,root)
%{_libdir}/libtcmalloc_minimal*.so.*

%files devel
%defattr(0644,root,root,0755)
%{_libdir}/*.so
%{_libdir}/*.a
%{_libdir}/pkgconfig/*
%{_includedir}/*

%files utils
%defattr(0644,root,root,0755)
%{_bindir}/*
%{_mandir}/*/*

%files doc
%defattr(-,root,root)
%{_datadir}/doc/%{pkgname}-%{version}

%changelog
* Sun Jan  5 2014 JoungKyun.Kim <http://oops.org> 1:2.1-2%{?dist}
- disable -fexceptions, as that breaks things on el6
- pass -pthread

* Fri Jan  3 2014 JoungKyun.Kim <http://oops.org> 1:2.1-1%{?dist}
- update 2.1
- add compat library 1.9.1

* Tue Jan 31 2012 JoungKyun.Kim <http://oops.org> 1:1.9.1-1%{?dist}
- first packaged
